\section{Testing Strategies}
Professional software developers do test their code and therefore a good testing strategy is mandatory.

\subsection{QA Should Find Nothing}
It must be the goal of the development department, that the QA doesn't find anything. Of course this wont always be the case but measure should be taken.

\paragraph{QA Is Part Of The Team}
The developers and the QA team should work together to secure the needed quality of the system.

\paragraph{QA As Specifiers}
The work of QA with the business should be taken as a specification sheet to create automated acceptance test that create a real specification. 

\subsection{The Test Automation Pyramid}
The test automation pyramid is a graphical description of which tests should be written for every project and how much of them. Make sure to build the pyramid form the bottom.

\paragraph{Unit Tests}
They specify the software at the lowest level possible. Unit test should reach close to 100\% coverage. 

\paragraph{Component Tests}
Test the individual components of the system. The parts of the system do encapsulate the business roles, therefore the tests do acceptance test for the business rules.

These test cover roughly half of the system and most of the time test happy paths.

\paragraph{Integration Tests}
They test the work of different components together, and not business rules. 
These tests are mostly written by architects and lead designers of the systems. The test ensure a working architecture.

\paragraph{System Tests}
Are the ultimate integration test of a system. The test the hole system in order to make sure every component does work together.
Also these test are written by architects and technical leads and cover about 10\% of the system.

\paragraph{Manual Exploratory Tests}
These test are done by humans and should not be automated. These are to make sure that the system does not break under special handling of users.